#ifndef _AisaR47_H_
#define _AisaR47_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AISA47_MAX_SLOTS 	16
#define	AISA47_SLOT_AUTO	((WORD) ~0U)
#define	AISA47_PORT_0		0
#define	AISA47_PORT_1		1

// G[R[h
#define AISA47_SUCCESS				0	// ُȂ
#define AISA47_ERR_SYSTEM			1	// GetLastError sĂ
#define AISA47_ERR_NO_DEVICE		2	// gp\ȃfoCXȂ
#define AISA47_ERR_IN_USE			3	// w肳ꂽXbg͎gp
#define AISA47_ERR_INVALID_SLOT		4	// Ș_Xbgԍ
#define AISA47_ERR_RESOURCE			5	// \[XG[
#define AISA47_ERR_INVALID_PORT		6	// ȃ|[gԍ
#define AISA47_ERR_INVALID_ARGUMENT	7	// Ȉ

#define AISA47_MAX_MEM		9
#define AISA47_MAX_IO		20
#define AISA47_MAX_IRQ		7
#define AISA47_MAX_DMA		7

//======================================================================
// \[X\
//======================================================================
typedef struct {
	DWORD	dwNumMemWindows;                   // EChE	gp
	DWORD	dwMemBase		[AISA47_MAX_MEM];  // MWx[XAhX		gp
	DWORD	dwMemLength		[AISA47_MAX_MEM];  // MW					gp
	DWORD	dwMemAttrib		[AISA47_MAX_MEM];  // MW				gp
	DWORD	dwNumIOPorts;                      // I/O|[g
	DWORD	dwIOPortBase	[AISA47_MAX_IO];   // I/O|[gx[XAhX
	DWORD	dwIOPortLength	[AISA47_MAX_IO];   // I/O|[g
	DWORD	dwNumIRQs;                         // IRQ					gp
	DWORD	dwIRQRegisters	[AISA47_MAX_IRQ];  // IRQXg				gp
	DWORD	dwIRQAttrib		[AISA47_MAX_IRQ];  // IRQXg			gp
	DWORD	dwNumDMAs;                         // DMA`l			gp
	DWORD	dwDMALst		[AISA47_MAX_DMA];  // DMA`lXg		gp
	DWORD	dwDMAAttrib		[AISA47_MAX_DMA];  // DMA`lXg	gp
	DWORD	dwReserved1		[3];               // \					gp
} AISA47RESOURCE;

typedef		AISA47RESOURCE *PAISA47R;
typedef		AISA47RESOURCE FAR *LPAISA47R;

//-- ȉAPI --
//======================================================================
// VxD  DLL ̃o[W擾
//======================================================================
BOOL WINAPI Aisa47GetVersion(
	PDWORD		pdwDllVer,		// VxD Version
	PDWORD		pdwVxDVer );	// DLL Version
	
//======================================================================
// foCXgp錾
//======================================================================
BOOL WINAPI Aisa47Create(
	PWORD pwLogSlot );			// Xbgԍ( 0`15 or SLOT_AUTO )
	
//======================================================================
// foCXJ
//======================================================================
BOOL WINAPI Aisa47Close(
	WORD wLogSlot );			// Xbgԍ( 0`15 )
	
//======================================================================
// \[X擾
//======================================================================
BOOL WINAPI Aisa47GetResource(
	WORD	wLogSlot,			// Slot
	AISA47RESOURCE *pRes );		// \[X\̂̃|C^
	
//======================================================================
// C|[g
//======================================================================
BOOL WINAPI Aisa47InPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 1 )
	PBYTE	pbValue );			// l
	
//======================================================================
// AEg|[g
//======================================================================
BOOL WINAPI Aisa47OutPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 1 )
	BYTE	bValue );			// l
	
//======================================================================
// Ōw肳ꂽXbgŔsꂽG[R[ho
//======================================================================
DWORD WINAPI Aisa47GetLastError(
	WORD	wLogSlot );			// Slot

#ifdef __cplusplus
}
#endif
#endif
